#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <wiringPi.h>
#include <wiringPi.h>

#define SE10 4
#define LED 17

int main(){
	
	if(wiringPiSetupGpio() == -1) {
		return 1;}
	int mode, speed, dist;
	int val=0;
	int pres=0;
	double volt;
	//char buf[256];
	run_state_t state;
	pinMode(SE10, INPUT);
	
	if(arduino_open() != 0) return -1;


	while(1){
		printf("0:stop  1:straight  2:rotate  3:get_mode  4:get_volt  5:quit 6:hunsahtest 7:get_pres\n");
		scanf("%d",&mode);
		
		switch(mode){
		case 0:
			request_set_runmode(STP, 0, 0);
			break;
		case 1:
			printf("speed? [cm/s]\n");
			scanf("%d",&speed);
			printf("dist? [cm]\n");
			scanf("%d",&dist);
			
			request_set_runmode(STR, speed, dist);
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}

			break;
		case 2:
			printf("speed? [deg/s]\n");
			scanf("%d",&speed);
			
			printf("angle? [deg]\n");
			scanf("%d",&dist);
			
			request_set_runmode(ROT, speed, dist);
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}
			break;
		case 3:
			request_get_runmode(&state, &speed, &dist);
			printf("state = %s\n",((state == STR) ? "STR" : (state == ROT) ? "ROT" : "STP"));
			break;
		case 4:
			request_get_batt(&volt);
			printf("batt = %4.2lf\n", volt);
			break;
		case 5:
			return 0;
		case 6:
			
			while(1){
				val = digitalRead(SE10);
				if(val == HIGH){
					printf("HIGH\n");
					delay(200);
					request_set_runmode(STR, 50, 100);
					while(1){
					request_get_runmode(&state, &speed, &dist);
					if( state == STP ) break;
					}
					
				}else{
					printf("LOw\n");
					delay(100);
				}
			}
			
			break;
		case 7:
			request_get_pres(&pres);
			printf("pres =%d\n", pres);
			break;
			
		case 8:
		
			printf("speed? [cm/s]\n");
			scanf("%d",&speed);
			printf("dist? [cm]\n");
			scanf("%d",&dist);
			request_set_runmode(HNS, speed, dist);
			while(1){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}
		default:
			break;
		}
	}
	
	arduino_close();
	return 0;
}
